# coding: utf-8

"""
    ClickSend v3 API

     This is an official SDK for [ClickSend](https://clicksend.com)  Below you will find a current list of the available methods for clicksend.  *NOTE: You will need to create a free account to use the API. You can register [here](https://dashboard.clicksend.com/#/signup/step1/)..*   # noqa: E501

    OpenAPI spec version: 3.1
    Contact: support@clicksend.com
    Generated by: https://github.com/clicksend-api/clicksend-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from clicksend_client.configuration import Configuration


class DeliveryIssue(object):
    """NOTE: This class is auto generated by the clicksend code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      clicksend_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    clicksend_types = {
        'message_id': 'str',
        'type': 'str',
        'description': 'str',
        'client_comments': 'str',
        'email_address': 'str'
    }

    attribute_map = {
        'message_id': 'message_id',
        'type': 'type',
        'description': 'description',
        'client_comments': 'client_comments',
        'email_address': 'email_address'
    }

    discriminator_value_class_map = {
        
    }

    def __init__(self, message_id=None, type=None, description=None, client_comments=None, email_address=None, _configuration=None):  # noqa: E501
        """DeliveryIssue - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._message_id = None
        self._type = None
        self._description = None
        self._client_comments = None
        self._email_address = None
        self.discriminator = 'classType'

        if message_id is not None:
            self.message_id = message_id
        self.type = type
        self.description = description
        if client_comments is not None:
            self.client_comments = client_comments
        self.email_address = email_address

    @property
    def message_id(self):
        """Gets the message_id of this DeliveryIssue.  # noqa: E501

        The message id of the message.  # noqa: E501

        :return: The message_id of this DeliveryIssue.  # noqa: E501
        :rtype: str
        """
        return self._message_id

    @message_id.setter
    def message_id(self, message_id):
        """Sets the message_id of this DeliveryIssue.

        The message id of the message.  # noqa: E501

        :param message_id: The message_id of this DeliveryIssue.  # noqa: E501
        :type: str
        """

        self._message_id = message_id

    @property
    def type(self):
        """Gets the type of this DeliveryIssue.  # noqa: E501

        The type of message, must be one of the following values SMS, MMS, VOICE, EMAIL_MARKETING, EMAIL_TRANSACTIONAL, FAX, POST.  # noqa: E501

        :return: The type of this DeliveryIssue.  # noqa: E501
        :rtype: str
        """
        return self._type

    @type.setter
    def type(self, type):
        """Sets the type of this DeliveryIssue.

        The type of message, must be one of the following values SMS, MMS, VOICE, EMAIL_MARKETING, EMAIL_TRANSACTIONAL, FAX, POST.  # noqa: E501

        :param type: The type of this DeliveryIssue.  # noqa: E501
        :type: str
        """
        if self._configuration.client_side_validation and type is None:
            raise ValueError("Invalid value for `type`, must not be `None`")  # noqa: E501

        self._type = type

    @property
    def description(self):
        """Gets the description of this DeliveryIssue.  # noqa: E501

        The description of the message.  # noqa: E501

        :return: The description of this DeliveryIssue.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this DeliveryIssue.

        The description of the message.  # noqa: E501

        :param description: The description of this DeliveryIssue.  # noqa: E501
        :type: str
        """
        if self._configuration.client_side_validation and description is None:
            raise ValueError("Invalid value for `description`, must not be `None`")  # noqa: E501

        self._description = description

    @property
    def client_comments(self):
        """Gets the client_comments of this DeliveryIssue.  # noqa: E501

        The user's comments.  # noqa: E501

        :return: The client_comments of this DeliveryIssue.  # noqa: E501
        :rtype: str
        """
        return self._client_comments

    @client_comments.setter
    def client_comments(self, client_comments):
        """Sets the client_comments of this DeliveryIssue.

        The user's comments.  # noqa: E501

        :param client_comments: The client_comments of this DeliveryIssue.  # noqa: E501
        :type: str
        """

        self._client_comments = client_comments

    @property
    def email_address(self):
        """Gets the email_address of this DeliveryIssue.  # noqa: E501

        The user's email address.  # noqa: E501

        :return: The email_address of this DeliveryIssue.  # noqa: E501
        :rtype: str
        """
        return self._email_address

    @email_address.setter
    def email_address(self, email_address):
        """Sets the email_address of this DeliveryIssue.

        The user's email address.  # noqa: E501

        :param email_address: The email_address of this DeliveryIssue.  # noqa: E501
        :type: str
        """
        if self._configuration.client_side_validation and email_address is None:
            raise ValueError("Invalid value for `email_address`, must not be `None`")  # noqa: E501

        self._email_address = email_address

    def get_real_child_model(self, data):
        """Returns the real base class specified by the discriminator"""
        discriminator_value = data[self.discriminator].lower()
        return self.discriminator_value_class_map.get(discriminator_value)

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.clicksend_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(DeliveryIssue, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, DeliveryIssue):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, DeliveryIssue):
            return True

        return self.to_dict() != other.to_dict()
